Require Import Program.

Require Import
        CSL.HList
        CSL.Syntax
        CSL.Definitions
        CSL.Analysis.AbstractValues
        CSL.Analysis.Generic.

Set Implicit Arguments.

Definition arg_eval_id {Δ τ} (e : exp Δ τ) (m : value_map Δ) :=
      match e with
      | Var v => hget m v
      | @Lit _ t l => ActualSet (singleton (tyDenote_dec_eq t) l)
      | _ => FullSet
      end.

Program Instance id_predicate_analysis_abstract_set : @PredicateAnalysis abstract_set _ abstract_set_setlattice :=
  {
    arg_eval := @arg_eval_id;
    analysis _ m _ := Some m
  }.
Next Obligation. (* arg_eval_correct *)
  dependent destruction e; simpl; intros; intuition.
Defined.
Next Obligation. (* arg_eval_monotone *)
  dependent destruction e; simpl; auto.
Defined.
Next Obligation. (* analysis_dec *)
  intros.
  left; eauto.
Defined.
Next Obligation. (* analysis_monotone *)
  dependent destruction x.
  simpl; auto.
  dependent destruction x1.
  simpl; auto.
  dependent destruction x1.
  simpl; auto.
  dependent destruction x1.
  simpl; auto.
  simpl.
  apply H.
Defined.
