Require Import Bool List.

Ltac simpl_hyp :=
  simpl in *; repeat match goal with
  | [ H : (andb _ _ = true) |- _ ] => apply andb_true_iff in H
  | [ H : (orb _ _ = true) |- _ ] => apply orb_true_iff in H
  | [ H : (existsb _ _ = true) |- _ ] => apply existsb_exists in H
  | [ H : (List.In _ (map _ _)) |- _ ] => apply in_map_iff in H
  | [ H : _ /\ _ |- _ ] => destruct H
  | [ H : _ \/ _ |- _ ] => destruct H
  | [ H : exists x, _ |- _ ] => destruct H
  end.

Ltac simpl_goal :=
  simpl;
  repeat match goal with
         | [ |- (andb _ _ = true) ] => apply andb_true_iff
         | [ |- (orb _ _ = true) ] => apply orb_true_iff
         | [ |- (existsb _ _ = true) ] => apply existsb_exists
         | [ |- (List.In _ (map _ _)) ] => apply in_map_iff
         | [ |- _ /\ _ ] => split
         end.
  
Ltac inv H := inversion H; subst; clear H.